// ColorScr.DLL by Steven Lawrance
#include <stdarg.h>

// Standard Colors
#define COLOR_BLACK			PALETTERGB(0, 0, 0),
#define COLOR_RED				PALETTERGB(191, 0, 0)
#define COLOR_GREEN			PALETTERGB(0, 191, 0)
#define COLOR_BROWN			PALETTERGB(171, 87, 0)
#define COLOR_YELLOW			PALETTERGB(128, 128, 0)
#define COLOR_BLUE			PALETTERGB(0, 0, 191)
#define COLOR_MAGENTA		PALETTERGB(191, 0, 191)
#define COLOR_CYAN			PALETTERGB(0, 191, 191)
#define COLOR_WHITE			PALETTERGB(192, 192, 192)
#define COLOR_LIGHTBLACK	PALETTERGB(128, 128, 128)
#define COLOR_LIGHTRED		PALETTERGB(255, 0, 0)
#define COLOR_LIGHTGREEN	PALETTERGB(0, 255, 0)
#define COLOR_LIGHTYELLOW	PALETTERGB(255, 255, 0)
#define COLOR_LIGHTBLUE		PALETTERGB(0, 0, 255)
#define COLOR_LIGHTMAGENTA	PALETTERGB(255, 0, 255)
#define COLOR_LIGHTCYAN		PALETTERGB(0, 255, 255)
#define COLOR_LIGHTWHITE	PALETTERGB(255, 255, 255)

// Compatability Constants
#define BLACK					0
#define BLUE					1
#define GREEN					2
#define CYAN					3
#define RED						4
#define MAGENTA				5
#define BROWN					6
#define LIGHTGRAY				7
#define DARKGRAY				8
#define LIGHTBLUE				9
#define LIGHTGREEN			10
#define LIGHTCYAN				11
#define LIGHTRED				12
#define LIGHTMAGENTA			13
#define YELLOW					14
#define WHITE					15
#define BLINK					128

BOOL FAR PASCAL scrInitialize(LPSTR windowName, int x, int y, int rows, int columns, BOOL closeFlag);
void FAR PASCAL scrUninitialize(void);
void FAR PASCAL clreol(void);
void FAR PASCAL clrscr(void);
void FAR PASCAL gotoxy(int x, int y);
int FAR PASCAL wherex(void);
int FAR PASCAL wherey(void);
int FAR PASCAL fgetchar(void);
int FAR PASCAL getch(void);
int FAR PASCAL getchar(void);
int FAR PASCAL getche(void);
LPSTR FAR PASCAL gets(LPSTR s);
int FAR PASCAL kbhit(void);
void FAR PASCAL perror(LPCSTR s);
int FAR PASCAL printf(LPCSTR format, ...);
int FAR PASCAL putch(int c);
int FAR PASCAL putchar(int c);
int FAR PASCAL puts(LPCSTR s);
int FAR PASCAL scanf(LPCSTR format, ...);
//int FAR PASCAL vprintf(LPCSTR *format, va_list arglist);
//int FAR PASCAL vscanf(LPCSTR *format, va_list arglist);
void FAR PASCAL textcolor(int newcolor);
void FAR PASCAL textbackground(int newcolor);
int FAR PASCAL movetext(int left, int top, int right, int bottom, int destleft, int desttop);
int FAR PASCAL ungetch(int ch);
void FAR PASCAL setAboutText(LPSTR text);
void FAR PASCAL displayAbout(void);
void FAR PASCAL flushinput(void);
int FAR PASCAL fgetchar(void);
int FAR PASCAL getch(void);
int FAR PASCAL getchar(void);
int FAR PASCAL getche(void);
LPSTR FAR PASCAL gets(LPSTR s);
void FAR PASCAL perror(LPCSTR s);
int FAR PASCAL vprintf(LPCSTR format, va_list arglist);
int FAR PASCAL vscanf(LPCSTR format, va_list arglist);
int FAR PASCAL scanf(LPCSTR format, ...);
void FAR PASCAL setCompatibilityMode(BOOL standardC);
void FAR PASCAL setWindowExitMode(BOOL closeProgram);

