// SL-OS v1.0 Run File

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <io.h>
#include <string.h>
#include <fcntl.h>
#include "slosdlli.h"
#include <stdlib.h>

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
BOOL CALLBACK _export AboutDlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMAboutDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);

HINSTANCE ghInstance;
char FileName[144];
char DOSNam[12];
char SLOSNam[60];
FILE *gfh;

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "SL-OS v1.0 Runtime for Windows";
   HWND        hWnd;
   MSG         msg;
   HMENU       hMenu;

   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.lpszClassName = ProgName;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
      wndclass.lpszMenuName  = "MAIN";
      wndclass.style         = CS_VREDRAW | CS_HREDRAW;

      RegisterClass(&wndclass);
   }

   hWnd = CreateWindow(ProgName, ProgName,    
                       WS_OVERLAPPEDWINDOW,     
                       CW_USEDEFAULT, CW_USEDEFAULT,          
                       CW_USEDEFAULT, CW_USEDEFAULT,          
                       NULL, NULL, hInstance, NULL);

   ghInstance = hInstance;
   hMenu = LoadMenu(hInstance, "MAIN");
   SetMenu(hWnd, hMenu);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_PAINT :
      { 
         HDC         PaintDC;
         RECT        rect;
         PAINTSTRUCT ps;

         PaintDC = BeginPaint(hWnd, &ps);
         GetClientRect(hWnd, &rect);

         DrawText(PaintDC, "SL-OS v1.0 Runtime for Windows",
                  -1, &rect, DT_SINGLELINE | DT_CENTER | DT_VCENTER);

         EndPaint(hWnd, &ps);
         return 0;
      }

      case WM_DESTROY :
      {
         PostQuitMessage(0);
         return 0;
      }
      case WM_COMMAND :
      {
	 return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (id)
   {
     case 100 :
     {
       DestroyWindow(hWnd);
       break;
     }
     case 101 :
     {
       DLGPROC AbtDlgProc;

       AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)AboutDlgProc, ghInstance);
       DialogBox(ghInstance, "OPENOLD", hWnd, AbtDlgProc);
       FreeProcInstance((FARPROC)AbtDlgProc);
       if (strcmp(FileName, "") != 0)
       {
	 FILE *FileHandle;
	 if (access(FileName, 0) == 0)
         {
	   char TestCh[20];
	   FileHandle = fopen(FileName, "r");
	   OldSLOS(hWnd, SLOSNam, FileName, FileHandle);
	   MessageBeep(MB_ICONASTERISK);
           MessageBox(hWnd, "Thanks for using SL-OS v1.0 Runtime for Windows!", "Program Done", MB_OK | MB_ICONASTERISK);
	 }
	 if (access(FileName, 0) != 0)
         {
	   MessageBeep(MB_ICONSTOP);
	   MessageBox(hWnd, "File Doesn't Exist!", "Program Start Error", MB_OK | MB_ICONSTOP);
	 }
	 fclose (FileHandle);
       }
       break;
     }
   }
}
#pragma argused
BOOL CALLBACK _export AboutDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	SetDlgItemText(hDlg, 200, "!SSL!.FAT");
	EnableWindow(GetDlgItem(hDlg, 203), WS_DISABLED);
	SetDlgItemText(hDlg, 203, "No File Selected");
	EnableWindow(GetDlgItem(hDlg, 204), WS_DISABLED);
	SetDlgItemText(hDlg, 204, "This File Is Empty");
	if (access("!SSL!.FAT", 0) == 0)
        {
	  char SLOSNam[60];
          char DOSNam[15];
	  FILE *FilStream;
	  FilStream = fopen("!SSL!.FAT", "r");
	  fgets(SLOSNam, 60, FilStream);
	  while (feof(FilStream) == 0)
	  {
	    fgets(DOSNam, 15, FilStream);
            SLOSNam[strlen(SLOSNam) - 1] = '\0';
	    DOSNam[strlen(DOSNam) - 1] = '\0';
	    SendDlgItemMessage(hDlg, 202, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) SLOSNam));
	    SendDlgItemMessage(hDlg, 205, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) DOSNam));
	    fgets(SLOSNam, 60, FilStream);
	  }
	  fclose(FilStream);
	}
	return TRUE;
      }
      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMAboutDlgCommand_Handler);
      }
   }

   return FALSE;
}
#pragma argsused
void WMAboutDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 1 :
     {
       char FATDir[144];
       char FATChk[2];
       DWORD dwIndex;
       dwIndex = SendDlgItemMessage(hDlg, 202, LB_GETCURSEL, 0, 0);
       if (dwIndex != LB_ERR)
       {
         SendDlgItemMessage(hDlg, 205, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) DOSNam));
	 SendDlgItemMessage(hDlg, 202, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) SLOSNam));
	 GetDlgItemText(hDlg, 206, FATDir, 144);
         if (strcmp(FATDir, "") != 0)
         {
           strrev(FATDir);
           strncpy(FATChk, FATDir, 1);
           FATChk[1] = '\0';
           strrev(FATDir);
           if (strcmp(FATChk, "\\") != 0)
           {
             strcat(FATDir, "\\");
           }
         }
         strcat(FATDir, DOSNam);
         strcpy(FileName, FATDir);
       }
       EndDialog(hDlg, 0);
       break;
     }
     case 2 :
     {
       strcpy(FileName, "");
       EndDialog(hDlg, 0);
       break;
     }
     case 201 :
     {
       char FATName[13];
       char FATDir[144];
       char FATChk[2];
       GetDlgItemText(hDlg, 200, FATName, 13);
       SendDlgItemMessage(hDlg, 202, LB_RESETCONTENT, 0, 0L);
       SendDlgItemMessage(hDlg, 205, LB_RESETCONTENT, 0, 0L);
       EnableWindow(GetDlgItem(hDlg, 203), WS_DISABLED);
       SetDlgItemText(hDlg, 203, "No File Selected");
       EnableWindow(GetDlgItem(hDlg, 204), WS_DISABLED);
       SetDlgItemText(hDlg, 204, "This File Is Empty");
       GetDlgItemText(hDlg, 206, FATDir, 144);
       if (strcmp(FATDir, "") != 0)
       {
         strrev(FATDir);
         strncpy(FATChk, FATDir, 1);
         FATChk[1] = '\0';
         strrev(FATDir);
         if (strcmp(FATChk, "\\") != 0)
	 {
           strcat(FATDir, "\\");
         }
       }
       strcat(FATDir, FATName);
       if (access(FATDir, 0) == 0)
       {
	 char SLOSNam[60];
         char DOSNam[15];
	 FILE *FilStream;
	 FilStream = fopen(FATDir, "r");
	 fgets(SLOSNam, 60, FilStream);
	 SendDlgItemMessage(hDlg, 202, LB_RESETCONTENT, 0, 0L);
	 SendDlgItemMessage(hDlg, 205, LB_RESETCONTENT, 0, 0L);
	 while (feof(FilStream) == 0)
	 {
	   fgets(DOSNam, 15, FilStream);
           SLOSNam[strlen(SLOSNam) - 1] = '\0';
	   DOSNam[strlen(DOSNam) - 1] = '\0';
	   SendDlgItemMessage(hDlg, 202, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) SLOSNam));
	   SendDlgItemMessage(hDlg, 205, LB_ADDSTRING, 0, (LPARAM) ((LPSTR) DOSNam));
	   fgets(SLOSNam, 60, FilStream);
	 }
	 fclose(FilStream);
       }
       break;
     }
     case 202 :
     {
       if (codeNotify == LBN_SELCHANGE)
       {
         int FileStrm;
         long i;
         char DOSNam[12];
         char FATDir[144];
         char FATChk[2];
         DWORD dwIndex;
	 dwIndex = SendDlgItemMessage(hDlg, 202, LB_GETCURSEL, 0, 0);
         if (dwIndex != LB_ERR)
         {
	   SendDlgItemMessage(hDlg, 205, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) DOSNam));
	   SetDlgItemText(hDlg, 203, DOSNam);
	   GetDlgItemText(hDlg, 206, FATDir, 144);
	   if (strcmp(FATDir, "") != 0)
	   {
	     strrev(FATDir);
	     strncpy(FATChk, FATDir, 1);
	     FATChk[1] = '\0';
             strrev(FATDir);
	     if (strcmp(FATChk, "\\") != 0)
	     {
               strcat(FATDir, "\\");
             }
           }
           strcat(FATDir, DOSNam);
	   FileStrm = open(FATDir, O_RDONLY);
	   i = filelength(FileStrm);
	   if (i == -1)
	   {
	     SetDlgItemText(hDlg, 204, "Cannot Read File");
	     EnableWindow(GetDlgItem(hDlg, 203), WS_DISABLED);
	     EnableWindow(GetDlgItem(hDlg, 204), WS_DISABLED);
	   }
	   else
           {
	     SetDlgItemInt(hDlg, 204, i, FALSE);
	     EnableWindow(GetDlgItem(hDlg, 203), WM_ENABLE);
	     EnableWindow(GetDlgItem(hDlg, 204), WM_ENABLE);
	   }
	   close(FileStrm);
         }
       }
       break;
     }   
   }
}
