#include "slopcfg.h"
#include <owl.h>
#include <windows.h>

class TIcon : public TApplication
  {
  public:
  TIcon (LPSTR lpszName, HINSTANCE hInstance,
		   HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
		   int nCmdShow);
  virtual void InitMainWindow ();
  void CloseWindow();
  };
class TIconWindow : public TWindow
  {
  private:
    HBITMAP MainBmp;
    HBITMAP MainDownBmp;
    HBITMAP ByeBmp;
  public :
   TIconWindow(PTWindowsObject AParent, LPSTR ATitle);
    virtual LPSTR GetClassName ();
    virtual void GetWindowClass (WNDCLASS&);
    virtual void SetupWindow();
    virtual void WMLButtonDown(RTMessage Msg) = [WM_FIRST + WM_LBUTTONDOWN];
    virtual void WMLButtonUp(RTMessage Msg) = [WM_FIRST + WM_LBUTTONUP];
    virtual void Paint( HDC PaintDC, PAINTSTRUCT&);
    virtual void CMAbout(RTMessage Msg) = [CM_FIRST + CM_ABOUT];
    virtual void CMSettings(RTMessage Msg) = [CM_FIRST + CM_SETTINGS];
    void DrawBMP( HDC DC, int X, int Y, HBITMAP BitMap );
  };

class TSettingsDialog : public TDialog
  {
  public :
  TSettingsDialog(PTWindowsObject AParent, LPSTR AName)
    : TDialog(AParent, AName) {};

  };

class TAboutDialog : public TDialog
  {
  public :
  TAboutDialog(PTWindowsObject AParent, LPSTR AName)
    : TDialog(AParent, AName) {};
    void ButtonDown(RTMessage Msg) = [ID_FIRST + AB_BDOWN]
     {
     CloseWindow();
     };
    void Try(RTMessage Msg) = [ID_FIRST + AB_TRY]
     {
     MessageBeep(MB_ICONASTERISK);
     MessageBox(HWindow, "If you enjoy this runtime version of SL-OS v2.0, please register it with the software author!  If you like the program but do not wish to register, you are missing out on some advantages such as DISCOUNTED upgrades and FREE BBS use with high-level security!  If you do not like this program, please delete it.", "SL-OS About - Try It Out!", MB_OK | MB_ICONASTERISK);

     };
    void Install(RTMessage Msg) = [ID_FIRST + AB_UPGRADE]
     {
     };
  };

void TIconWindow::SetupWindow()
{
  MainBmp = LoadBitmap( GetApplication()->hInstance, "BITMAP" );
  ByeBmp = LoadBitmap( GetApplication()->hInstance, "BYE" );
  MainDownBmp = LoadBitmap( GetApplication()->hInstance, "BITMAP2" );
}
void TIconWindow::Paint( HDC PaintDC, PAINTSTRUCT& )
{
	DrawBMP( PaintDC, 0, 0, MainBmp );
}
void TIconWindow::CMAbout(RTMessage)
{
     GetApplication()->ExecDialog(new TAboutDialog(this, "ABOUT"));
}
void TIconWindow::CMSettings(RTMessage)
{
     GetApplication()->ExecDialog(new TSettingsDialog(this, "CONFIG"));
}
void TIconWindow::DrawBMP( HDC DC, int X, int Y, HBITMAP BitMap )
{
	HDC MemDC;
	BITMAP bm;
	BOOL MadeDC;

	if ( DC == 0 )
	{
		DC = GetDC( HWindow );
		MadeDC = TRUE;
	}
	else
		MadeDC = FALSE;
	MemDC = CreateCompatibleDC( DC );
	SelectObject( MemDC, BitMap );
	GetObject( BitMap, sizeof( bm ), ( LPSTR ) &bm );
	BitBlt( DC, X, Y, bm.bmWidth, bm.bmHeight, MemDC, 0, 0, SRCCOPY );
	DeleteDC( MemDC );
	if ( MadeDC )
		ReleaseDC( HWindow, DC );
}
int PASCAL WinMain (HINSTANCE hInstance,   HINSTANCE hPrevInstance,
		    LPSTR lpszCmdLine, int nCmdShow)
    {
    TIcon Icon ("ICON", hInstance, hPrevInstance,
			 lpszCmdLine, nCmdShow);
    Icon.Run();
    return Icon.Status;
    }

TIcon::TIcon (LPSTR lpszName, HINSTANCE hInstance,
		    HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
		    int nCmdShow)
		:TApplication (lpszName, hInstance, hPrevInstance,
		    lpszCmdLine, nCmdShow)
    {
    }

void TIcon::InitMainWindow ()
    {
    MainWindow = new TIconWindow (NULL, "SL-OS For Windows");
    }
TIconWindow::TIconWindow(PTWindowsObject AParent, LPSTR ATitle) :
   TWindow(AParent, ATitle)
{
  DisableAutoCreate();
  Attr.Style = WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX;
   Attr.X = 20;
   Attr.Y = 20;
   Attr.H = 240;
   Attr.W = 322;
   AssignMenu("MENU");
}
void TIconWindow::WMLButtonDown(RTMessage)
{
DrawBMP( 0, 0, 0, MainDownBmp );
}
void TIconWindow::WMLButtonUp(RTMessage)
{
DrawBMP( 0, 0, 0, MainBmp );
DrawBMP( 0, 0, 0, ByeBmp );
WinExec("PROGMAN.EXE", SW_SHOW);
WinExec("ARIES.EXE", SW_SHOW);
CloseWindow();
}
LPSTR TIconWindow::GetClassName ()
    {
    return "MIN:MAIN";
    }
void TIconWindow::GetWindowClass (WNDCLASS& wc)
    {
    TWindow::GetWindowClass (wc);
    }