#include <windowsx.h>
#include <mmsystem.h>
#include <string.h>
#include "slos.h"
#include "slosdll.h"
#include <bwcc.h>
#include <stdio.h>

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export AbtDlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export OldDlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void WMAbtDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);
void WMOldDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);

HINSTANCE    ghInstance;
HACCEL       MainAcc;
HMENU        hMenu;

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "SL-OS 2.0 for Windows";
   HWND        hWnd;
   MSG         msg;

   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.style         = CS_VREDRAW | CS_HREDRAW;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon (wndclass.hInstance, "ICO2");
      wndclass.hCursor       = LoadCursor (wndclass.hInstance, "SLOS");
      wndclass.lpszMenuName  = "MAIN";
      wndclass.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1);
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.lpszClassName = ProgName;

      RegisterClass(&wndclass);
   }

   ghInstance = hInstance;

   hWnd = CreateWindow(ProgName, ProgName,    
		       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,          
                       600, 400,          
                       NULL, NULL, hInstance, NULL);

   MainAcc = LoadAccelerators(ghInstance, "MAINACC");
   hMenu = LoadMenu(ghInstance, "MAIN");
   SetMenu(hWnd, hMenu);
   ShowWindow(hWnd, nCmdShow);

   UpdateWindow(hWnd);

   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      TranslateAccelerator(hWnd, MainAcc, &msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_DESTROY :
      {
	DeleteObject(MainAcc);
	DeleteObject(hMenu);
	PostQuitMessage(0);
        return 0;
      }
      case WM_COMMAND :
      {
	return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (id)
   {
      case 101 :
      {
	//Create new MDI child
	break;
      }
      case 102 :
      {
	//Open MDI child
	break;
      }
      case 103 :
      {
	//save
	break;
      }
      case 104 :
      {
	//save as
	break;
      }
      case 105 :
      {
	//print
	break;
      }
      case 106 :
      {
	//print setup
	break;
      }
      case 107 :
      {
	//exit
	DestroyWindow(hWnd);
        break;
      }
      case 108 :
      {
	//cut
	break;
      }
      case 109 :
      {
	//copy
	break;
      }
      case 110 :
      {
	//paste
	break;
      }
      case 111 :
      {
	//new resource
	break;
      }
      case 112 :
      {
	//edit resource
	break;
      }
      case 113 :
      {
	//delete resource
	break;
      }
      case 114 :
      {
	//new object
	break;
      }
      case 115 :
      {
	//edit object
	break;
      }
      case 116 :
      {
	//delete object
	break;
      }
      case 117 :
      {
	//new old
	break;
      }
      case 118 :
      {
	//edit old
	DLGPROC AbtTheDlgProc;

	AbtTheDlgProc = (DLGPROC)MakeProcInstance((FARPROC)OldDlgProc, ghInstance);
	DialogBox(ghInstance, "OLDSLOS", hWnd, AbtTheDlgProc);
        FreeProcInstance((FARPROC)OldDlgProc);
        InvalidateRect(hWnd, NULL, TRUE);
	break;
      }
      case 119 :
      {
	//delete old
	break;
      }
      case 901 :
      {
	//command help
	break;
      }
      case 902 :
      {
	//slos 1.0 help
	break;
      }
      case 903 :
      {
	//procedure help
	break;
      }
      case 904 :
      {
	//help help
        WinExec("winhelp.exe winhelp.hlp", SW_SHOWNORMAL);
	break;
      }
      case 999 :
      {
	//about
	DLGPROC AbtTheDlgProc;

	AbtTheDlgProc = (DLGPROC)MakeProcInstance((FARPROC)AbtDlgProc, ghInstance);
	DialogBox(ghInstance, "GENERAL", hWnd, AbtTheDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
        InvalidateRect(hWnd, NULL, TRUE);
	break;
      }
    }
}

#pragma argsused
BOOL CALLBACK _export AbtDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	UINT SysRes;
	char AboutText[500] = {"SL-OS 2.0 for Windows was\ncreated by Aries Software in 1994\nby Steven Lawrance.  SL-OS and\nSL-OP v1.0 are products of\nAries Software.\n\n"};
        char TempStr[55];
	SysRes = GetFreeSystemResources(GFSR_SYSTEMRESOURCES);
	sprintf(TempStr, "Free Resources:  %d%%\n", SysRes);
        strcat(AboutText, TempStr);
	SetDlgItemText(hDlg, 500, AboutText);
	return TRUE;
      }

      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMAbtDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMAbtDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case IDOK :
    {
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      EndDialog(hDlg, 0);
      break;
    }
    case 998 :
    {
      MessageBeep(MB_ICONASTERISK);
      MessageBox(hDlg, "To exit the about dialog, click on OK, CANCEL, press [Esc] or [Ctrl] + [F4].", "About SL-OS Help", MB_OK | MB_ICONASTERISK);
      break;
    }
  }
}

#pragma argsused
BOOL CALLBACK _export OldDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	return TRUE;
      }

      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMOldDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMOldDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 1 :
    {
      if (SendMessage(GetDlgItem(hDlg, 500), BM_GETCHECK, 0, 0L))
      {
	// Edit as Resource
        MessageBox(hDlg, "Resource", "Edit", MB_OK);
      }
      if (SendMessage(GetDlgItem(hDlg, 501), BM_GETCHECK, 0, 0L))
      {
	// Edit as Text
	MessageBox(hDlg, "Text", "Edit", MB_OK);
      }
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      EndDialog(hDlg, 0);
      break;
    }
    case 998 :
    {
      MessageBeep(MB_ICONASTERISK);
      MessageBox(hDlg, "Select the method of editing you wish.  To cancel, press [Esc] or click on Cancel.", "Edit SL-OS v1.0 Code Help", MB_OK | MB_ICONASTERISK);
      break;
    }
  }
}