// SL-OS Control File

#include <windowsx.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>

//void WMDlgCommand_Handler(HWND hDlg, int id,
//                          HWND hwndCtl, UINT codeNotify);
#define _EXPORT huge
//BOOL FAR PASCAL _export DlgProc(HWND hDlg, UINT message,
//					WPARAM wParam, LPARAM lParam);
int FAR PASCAL _export WEP(int nShutDownFlag);
void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette);
void FAR PASCAL _export StretchPicture(HWND hWnd, char PicName[20], HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int ww, int wh, int bx, int by, int bw, int bh);
void FAR PASCAL _export RefreshPicture(HWND hWnd, HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int bx, int by, int bw, int bh);
void FAR PASCAL _export InitInstance(HINSTANCE hInstance, int inst);
void FAR PASCAL _export AboutB256DLL(HWND hWnd);
void FAR PASCAL _export SLOS(HWND hWnd, LPCSTR Command);
void FAR PASCAL _export SetSLOSFileName(LPCSTR FileToCopy);
BOOL FAR PASCAL _export OldSLOS(HWND hWnd, char Directory[144], char SLOSNam[60], char DOSName[160], FILE *FATHandle, LPCSTR Instruction);
BOOL FAR PASCAL _export DeletePic(HBITMAP BitmapHandle);
BOOL FAR PASCAL _export DeletePal(HPALETTE hNewPalette);
BOOL FAR PASCAL _export IllegalValue(HWND hWnd, char Command[142], char ErrorString[200], int LinePos);
HBITMAP FAR PASCAL _export GetPicFast(HWND hWnd, char PicName[20]);
HBITMAP FAR PASCAL _export GetPic256(HWND hWnd, char PicName[20]);
HPALETTE FAR PASCAL _export GetPicPal(void);
HINSTANCE FAR PASCAL _export GetDLLInstance(void);
BOOL CALLBACK _export OldSLOSDlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMOldSLOSDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);
BOOL CALLBACK _export ErrorDlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMErrorDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);
BOOL CALLBACK _export Retry10DlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMRetry10DlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);

RECT rect;
char szBuf[20];
LPSTR FileName;
short nColors, Count;
LPBITMAPINFO pBits;
HBITMAP BitmapHandle;
HPALETTE hNewPalette;
HINSTANCE ghInstance;
HINSTANCE dllInstance;
int gsx;
int gsy;
int gsv;
char gss[100];
char Err[142];
int erv;
char gsf[60];
char gsc[60];
char gns[60];
char gnf[160];
FILE *gfh;

#pragma argsused
int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpszCmdLine)
{
  if (wHeapSize > 0)
    UnlockData(0);
  pBits = NULL;
  BitmapHandle = NULL;
  hNewPalette = NULL;
  gsy = 1;
  gsx = 1;
  lstrcpy(gsc, "");
  dllInstance = hInstance;
  return 1;
}

#pragma argsused
int FAR PASCAL _export WEP(int nShutDownFlag)
{
  DeletePic(BitmapHandle);
  DeletePal(hNewPalette);
  return 1;
}

void FAR PASCAL _export InitInstance(HINSTANCE hInstance, int inst)
{
  if (inst != 0)
  {
    ghInstance = dllInstance;
  }
  if (inst == 0)
  {
    ghInstance = hInstance;
  }
}

#pragma argsused
void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette)
{
	if (hNewPalette)
	{
          HPALETTE hOldPalette;
	  HDC hDC = GetDC(hWnd);
	  hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
	  RealizePalette(hDC);
	  SelectPalette(hDC,hOldPalette,FALSE);
	  ReleaseDC(hWnd,hDC);
          DeleteObject(hOldPalette);
	};
}

#pragma argsused
void FAR PASCAL _export StretchPicture(HWND hWnd, char PicName[20], HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int ww, int wh, int bx, int by, int bw, int bh)
{
      HPALETTE hOldPalette;
      HDC hDC = GetDC(hWnd);
      BITMAP BM;
      HGLOBAL hBitmap = NULL;

      hBitmap  = LoadResource(ghInstance, FindResource(ghInstance, (LPSTR)PicName, RT_BITMAP));
      GetClientRect(hWnd, &rect);
      GetObject(BitmapHandle, sizeof(BITMAP), &BM);
	 if (wx == 0)
	   {
	   wx = rect.left;
	   };
	 if (wy == 0)
	   {
	   wy = rect.top;
	   };
	 if (ww == 0)
	   {
	   ww = rect.right;
	   };
	 if (wh == 0)
	   {
	   wh = rect.bottom;
	   };
	 if (bw == 0)
	   {
	   bw = BM.bmWidth;
	   };
	 if (bh == 0)
	   {
	   bh = BM.bmHeight;
	   };
      pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
      hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
      RealizePalette(hDC);
      StretchDIBits(hDC, wx, wy, ww, wh, bx, by, bw, bh, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS, SRCCOPY);
      SelectPalette(hDC,hOldPalette,FALSE);
      FreeResource(hBitmap);
      ReleaseDC(hWnd,hDC);
      DeleteObject(hBitmap);
      DeleteObject(hOldPalette);
      ValidateRect(hWnd,NULL);
}

#pragma argsused
void FAR PASCAL _export RefreshPicture(HWND hWnd, HBITMAP BitmapHandle, HPALETTE hNewPalette, int wx, int wy, int bx, int by, int bw, int bh)
{
         HBITMAP OldBitmapHandle;
	 BITMAP BM;
	 HDC hDC = GetDC(hWnd);
         HDC MemoryDC;
	 HPALETTE hOldPal;
	 GetClientRect(hWnd, &rect);
         GetObject(BitmapHandle, sizeof(BITMAP), &BM);
     	 if (wx == 0)
	   {
	   wx = rect.left;
	   };
	 if (wy == 0)
	   {
	   wy = rect.top;
	   };
	 if (bw == 0)
	   {
	   bw = BM.bmWidth;
	   };
	 if (bh == 0)
	   {
	   bh = BM.bmHeight;
	   };
	 if ( BitmapHandle )
           {
           MemoryDC = CreateCompatibleDC(hDC);
           OldBitmapHandle = (HBITMAP)SelectObject(MemoryDC, BitmapHandle);
	   hOldPal = SelectPalette( hDC, hNewPalette, FALSE);
           SetBkColor(hDC, 0L);
           SetTextColor(hDC, 0xFFFFFFL);
	   BitBlt(hDC, wx, wy, bw, bh, MemoryDC, bx, by, SRCCOPY);
	   SelectPalette( hDC, hOldPal, FALSE);
	   SelectObject(MemoryDC, OldBitmapHandle);
	   DeleteDC(MemoryDC);
	   ValidateRect(hWnd,NULL);
	   };
         ReleaseDC(hWnd, hDC);
         ReleaseDC(hWnd, MemoryDC);
	 DeleteObject(OldBitmapHandle);
	 DeleteObject(hOldPal);
}

HINSTANCE FAR PASCAL _export GetDLLInstance(void)
{
  return dllInstance;
}

void FAR PASCAL _export AboutB256DLL(HWND hWnd)
{
  MessageBeep(MB_ICONASTERISK);
  MessageBox(hWnd, "This file is one of the core components to SLOS 2.0 for Windows.  This file may be freely distributed.", "SLOS 2.0 for Windows", MB_OK | MB_ICONASTERISK);
}

#pragma argsused
HBITMAP FAR PASCAL _export GetPicFast(HWND hWnd, char PicName[20])
{
      HPALETTE hOldPalette;
      HGLOBAL hBitmap = NULL;
      HDC hDC = GetDC(hWnd);
      hBitmap = LoadResource(ghInstance, FindResource(ghInstance, (LPSTR)PicName, RT_BITMAP));
      pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
      hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
      RealizePalette(hDC);
      BitmapHandle = CreateDIBitmap(hDC, (LPBITMAPINFOHEADER)pBits, CBM_INIT, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS);
      SelectPalette(hDC,hOldPalette,FALSE);
      FreeResource(hBitmap);
      ReleaseDC(hWnd,hDC);
      DeleteObject(hOldPalette);
      return BitmapHandle;
}

#pragma argsused
HBITMAP FAR PASCAL _export GetPic256(HWND hWnd, char PicName[20])
{
      HPALETTE hOldPalette;
      RGBQUAD FAR  *pRgb;
      LPLOGPALETTE lpDstPal;

      HGLOBAL hBitmap = NULL;
      hNewPalette     = NULL;
      hBitmap  = LoadResource(ghInstance,
			    FindResource(ghInstance,
					(LPSTR)PicName, RT_BITMAP));
      if (!hBitmap)
      {
	MessageBeep(MB_ICONSTOP);
      }
      if ( hBitmap )
	{
	HDC hDC = GetDC(hWnd);
	pBits = (LPBITMAPINFO)GlobalLock(hBitmap);
	nColors = 1<<(pBits->bmiHeader.biBitCount);
	if ( nColors)
	  {
	  lpDstPal = (LPLOGPALETTE) GlobalLock( GlobalAlloc(
	  GHND, sizeof(LOGPALETTE) + ( (nColors - 1) * sizeof(PALETTEENTRY) )));
	  lpDstPal->palNumEntries = nColors;
	  lpDstPal->palVersion    = 0x300;
	  pRgb = pBits->bmiColors;
	  for (Count = 0; Count <= nColors; Count++)
	    {
	    lpDstPal->palPalEntry[Count].peRed   = pRgb[Count].rgbRed;
	    lpDstPal->palPalEntry[Count].peGreen = pRgb[Count].rgbGreen;
	    lpDstPal->palPalEntry[Count].peBlue  = pRgb[Count].rgbBlue;
	    lpDstPal->palPalEntry[Count].peFlags = 0;
	    }
	  }
	hNewPalette = CreatePalette(lpDstPal);
	GlobalFree( (HANDLE) GlobalHandle( HIWORD( lpDstPal) ) );
	hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
	RealizePalette(hDC);
	BitmapHandle = CreateDIBitmap(hDC, (LPBITMAPINFOHEADER)pBits, CBM_INIT, ((LPSTR) pBits + 40) + (nColors * sizeof(RGBQUAD)), pBits, DIB_RGB_COLORS);
	SelectPalette(hDC,hOldPalette,FALSE);
	FreeResource(hBitmap);
	ReleaseDC(hWnd,hDC);
	DeleteObject(hOldPalette);
	}

      return BitmapHandle;
}

#pragma argsused
HPALETTE FAR PASCAL _export GetPicPal(void)
{
      return hNewPalette;
}

#pragma argsused
BOOL FAR PASCAL _export DeletePic(HBITMAP BitmapHandle)
{
      return DeleteObject(BitmapHandle);
}

#pragma argsused
BOOL FAR PASCAL _export DeletePal(HPALETTE hNewPalette)
{
      return DeleteObject(hNewPalette);
}

#pragma argsused
BOOL FAR PASCAL _export OldSLOS(HWND hWnd, char Directory[144], char SLOSNam[60], char DOSName[160], FILE *FATHandle, LPCSTR Instruction, int Mode)
{
  DLGPROC AbtDlgProc;

  gsy = 1;
  gsx = 1;
  strcpy(gns, SLOSNam);
  strcpy(gnf, DOSName);

  if (Mode == 0)
  {
    
  gfh = fopen(DOSName, "r+");

  AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)OldSLOSDlgProc, ghInstance);
  DialogBox(dllInstance, "SLOS10", hWnd, AbtDlgProc);
  FreeProcInstance((FARPROC)AbtDlgProc);
  return TRUE;
}

/*#pragma argsused
void FAR PASCAL _export DisplayText(HWND hWnd, LPSTR Text, int x, int y)
{
  HDC Display = GetDC(hWnd);
  TextOut(Display, x, y, Text, sizeof (Text));
  DeleteDC(Display);
  ValidateRect(hWnd, NULL);
} */
#pragma argsused
void FAR PASCAL _export SetSLOSFileName(LPCSTR FileToCopy)
{
  lstrcpy(FileName, FileToCopy);
}

/*#pragma argsused
void FAR PASCAL _export DisplayNewBitmap(HWND hWnd, LPSTR BmpName, int x, int y)
{
  DeletePic(BitmapHandle);
  DeletePal(hNewPalette);
  BitmapHandle = GetPic256(hWnd, BmpName);
  hNewPalette = GetPicPal();
  RefreshPicture(hWnd, BitmapHandle, hNewPalette, x, y, 0, 0, 0, 0);
}
 
#pragma argsused
void FAR PASCAL _export DisplayDialog(HWND hWnd, LPSTR DlgName)
{
  DLGPROC AbtDlgProc;

  LoadString(ghInstance, 0, szBuf, 20);
  AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
  DialogBoxParam(ghInstance, DlgName, hWnd, AbtDlgProc, (LPARAM) "L");
  FreeProcInstance((FARPROC)AbtDlgProc);
  InvalidateRect(hWnd, NULL, TRUE);
}

#pragma argsused
void FAR PASCAL _export DisplayIcon(HWND hWnd, LPSTR IconName, int x, int y)
{
  MessageBox(NULL, "Feature Disabled in Version 2.0", "DisplayIcon", MB_OK | MB_ICONASTERISK);
}*/

#pragma argsused
void FAR PASCAL _export SLOS(HWND hWnd, LPCSTR Command)
{
/*  DLGPROC AbtDlgProc;

  LoadString(ghInstance, 0, szBuf, 20);
  AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
  DialogBoxParam(ghInstance, "SLOS", hWnd, AbtDlgProc, (LPARAM) "L");
  FreeProcInstance((FARPROC)AbtDlgProc);
  InvalidateRect(hWnd, NULL, TRUE);*/
}

/*#pragma argsused
BOOL FAR PASCAL _export DlgProc(HWND hDlg, UINT message,
					WPARAM wParam, LPARAM lParam)
{
return FALSE;
}

#pragma argsused
void WMDlgCommand_Handler(HWND hDlg, int id,
                          HWND hwndCtl, UINT codeNotify)
{}*/

#pragma argused
BOOL CALLBACK _export OldSLOSDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	char TmpStr[70];
	strcpy(TmpStr, "SL-OS 1.0 - ");
	strcat(TmpStr, gns);
        SetTimer(hDlg, 250, 300, NULL);
        SetWindowText(hDlg, TmpStr);
	return TRUE;
      }
      case WM_TIMER :
      {
	char Command[142];
	char Cmd[7];
        char ErrorString[200];
	int RetVal = 0-1;
        int LinePos;
        int Loops;
	KillTimer(hDlg, 250);
	{
          LinePos = 1;
          Loops = 0;
	  fgets(Command, 141, gfh);
	  Command[strlen(Command) - 2] = '\0';
	  while (feof(gfh) == 0)
          {
	    int i;
            Loops = Loops + 1;
	    RetVal = (0-1);
	    strcpy(ErrorString, "Code was not understood!");
	    i=2;
	    strncpy(Cmd, Command, i);
	    Cmd[i] = '\0';
	    strupr(Cmd);
	    if (strcmp(Cmd, "P!") == 0)
	    {
	      char TmpStr[500];
              char TmpStrb[500];
              int t;
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      strcpy(TmpStrb, "");
	      if (gsy >=26)
	      {
		for (t=201; t<=224; t++)
		{
		  GetDlgItemText(hDlg, t + 1, TmpStrb, 500);
		  if (strcmp(TmpStrb, "") != 0)
		  {
		    SetDlgItemText(hDlg, t, TmpStrb);
                  }
		}
		SetDlgItemText(hDlg, 225, "");
		gsy = 25;
              }
	      strcpy(TmpStrb, "");
	      if (gsx != 1)
              {
		for (t=1; t<=gsx - 1; t++)
	        {
                  strcat(TmpStrb, " ");
                }
              }
	      strcat(TmpStrb, TmpStr);
              GetDlgItemText(hDlg, 200 + gsy, TmpStr, 500);
	      if (strcmp(TmpStr, "") != 0)
	      {
		for (t=0; t<=79; t++)
		{
		  if (TmpStr[t] != TmpStrb[t])
		  {
		    if (TmpStrb[t] == ' ')
		    {
		      TmpStrb[t] = TmpStr[t];
                    }
		  }
		}
              }
	      SetDlgItemText(hDlg, 200 + gsy, TmpStrb);
	      gsy = gsy + 1;
              RetVal = 0;
	    }
	    if (strcmp(Cmd, "L#") == 0)
	    {
	      char TmpStra[5];
	      char TmpStrb[3];
	      strrev(Command);
	      strncpy(TmpStra, Command, 4);
	      TmpStra[4] = '\0';
	      strrev(Command);
	      strrev(TmpStra);
	      strncpy(TmpStrb, TmpStra, 2);
	      TmpStrb[2] = '\0';
	      gsx = atoi(TmpStrb);
	      RetVal = 0;
	      if (gsy >=26)
	      {
		gsy = 1;
		RetVal = -1;
        	strcpy(ErrorString, "While locating a position on\nthe screen, we noticed\nyour coordinates don't exist!");
	      }
	      strrev(TmpStra);
	      strcpy(TmpStrb, "");
	      strncpy(TmpStrb, TmpStra, 2);
              strrev(TmpStrb);
	      TmpStrb[2] = '\0';
	      gsy = atoi(TmpStrb);
	      if (gsx >=81)
	      {
		gsx = 1;
		RetVal = 0-1;
		strcpy(ErrorString, "While locating a position on\nthe screen, we noticed\nyour coordinates don't exist!");
	      }
	    }
	    if (strcmp(Cmd, "S#") == 0)
	    {
	      char TmpStr[500];
              char TmpTmp[142];
              long BefPos;
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 3);
	      TmpStr[strlen(Command) - 3] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      RetVal = atoi(TmpStr);
	      BefPos = ftell(gfh);
	      if (RetVal >= LinePos + 1)
	      {
		int t;
		for (t=1; t<=(RetVal - LinePos - 1); t++)
		{
	          fgets(TmpTmp, 142, gfh);
		}
		if (feof(gfh) != 0)
		{
		  fseek(gfh, BefPos, SEEK_SET);
		  strcpy(ErrorString, "The line specified exceeds file length.");
                  RetVal = -1;
		}
	      }
	      else
              {
	        if (RetVal <= LinePos - 1)
	        {
		  int t;
		  fseek(gfh, 0, SEEK_SET);
		  for (t=1; t<=RetVal - 1; t++)
		  {
		    fgets(TmpTmp, 142, gfh);
		  }
	        }
              }
	      strcpy(ErrorString, "You specified an invalid\nline.");
	    }
	    if (strcmp(Cmd, "C!") == 0)
	    {
	      int t;
	      for (t=201; t<=225; t++)
	      {
	        SetDlgItemText(hDlg, t, "");
	      }
              gsy = 1;
              gsx = 1;
	      RetVal = 0;
	    }
	    if (strcmp(Cmd, "ND") == 0)
	    {
	      char TmpStr[142];
	      fseek(gfh, 0, SEEK_END);
	      fgets(TmpStr, 142, gfh);
	      RetVal = (0-2);
	    }
	    if (strcmp(Cmd, "F$") == 0)
	    {
	      char TmpStr[500];
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      lstrcpy(gsf, TmpStr);
	      RetVal = 0;
	    }
	    if (strcmp(Cmd, "SV#") == 0)
	    {
	      char TmpStr[500];
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      gsv = atoi(TmpStr);
	      RetVal = 0;
	    }
	    if (strcmp(Cmd, "SV$") == 0)
	    {
	      char TmpStr[500];
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      lstrcpy(gss, TmpStr);
	      RetVal = 0;
	    }
	    if (strcmp(Cmd, "D$") == 0)
	    {
	      char TmpStr[500];
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      WinExec(TmpStr, SW_SHOWNORMAL);
	      RetVal = 0;
	    }
	    if (strcmp(Cmd, "I#") == 0)
	    {
	      strcpy(Cmd, "I$");
	    }
	    if (strcmp(Cmd, "I$") == 0)
	    {
	      char TmpStr[500];
	      char QueStr[499];
	      char NumStr[2];
	      char TmpChr[10];
	      strcpy(ErrorString, "Cats are invading the planet earth!");
	      strrev(Command);
	      strncpy(TmpStr, Command, strlen(Command) - 2);
	      TmpStr[strlen(Command) - 2] = '\0';
	      strrev(Command);
	      strrev(TmpStr);
	      strncpy(NumStr, TmpStr, 1);
	      NumStr[1] = '\0';
	      i = atoi(NumStr);
	      strrev(TmpStr);
	      strncpy(QueStr, TmpStr, strlen(TmpStr) - 1);
	      QueStr[strlen(TmpStr) - 1] = '\0';
	      strrev(TmpStr);
	      strrev(QueStr);
	      if (!gfh)
	      {
		strcpy(ErrorString, "Your EXE file didn't properly\nprovide a file handle!");
		RetVal = (0-1);
	      }
/*	      else
	      {
                char TmpTmp[142];
		char TmpCat[2];
		int  s;
                int  t;
		long BefPos;
	        BefPos = ftell(gfh);
		for (t=1; t<=i; t++)
		{
		  fgets(TmpCat, 142, gfh);
		  fgets(TmpTmp, 142, gfh);
		  if (feof(gfh) != 0)
		  {
		    fseek(gfh, BefPos, SEEK_SET);
		    strcpy(ErrorString, "Your I$ / I# statement isn't valid.  Check the instructions.");
		    RetVal = -1;
                    t = i;
		  }
		  else
		  {
		  }
		}
	      }*/
	    }
	    if (RetVal == 0-1)
            {
              char Cms[7];
	      i=6;
	      strncpy(Cmd, Command, i);
	      Cms[i] = '\0';
	      if (strcmp(Cms, "SYSND!") == 0)
              {
                strcpy(Cmd, Cms);
		strcpy(ErrorString, "Error exiting Windows.  Choose \"Ignore\" to continue.");
		if (MessageBox(hDlg, "Exiting Windows closes all open applications and may result in lost work if you haven't saved.  Are you still sure?", "Exit Windows", MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2) == IDYES)
		{
	          fseek(gfh, 0, SEEK_END);
	          fgets(NULL, 141, gfh);
		  RetVal = (0-2);
		  ExitWindows(NULL, 0);
		}
		else
		{
		  RetVal = 0;
                }
              }
            }
	    if (RetVal == 0-1)
	    {
	      BOOL ErrorRes;
	      ErrorRes = IllegalValue(hDlg, Command, ErrorString, LinePos);
	      if (ErrorRes == 3)
	      {
                fseek(gfh, 0, SEEK_END);
	        fgets(NULL, 141, gfh);
		RetVal = (0-2);
	      }
	      if (ErrorRes == 4)
	      {
		RetVal = (0-3);
	      }
	      if (ErrorRes == 5)
	      {
		RetVal = (0-1);
	      }
	    }
	    if (RetVal != 0-3)
            {
              LinePos = LinePos + 1;
	      fgets(Command, 141, gfh);
	      Command[strlen(Command) - 2] = '\0';
              RetVal = (0-1);
	      Loops = 0;
            }
	    if (Loops == 2)
	    {
	      int ErrorVal = IllegalValue(hDlg, Command, "An Endless Loop Has Been Detected!", LinePos);
	      if (ErrorVal == 3)
              {
	        fseek(gfh, 0, SEEK_END);
	        fgets(NULL, 141, gfh);
              }
	      else
	      {
                Loops = 0;
              }
	    }
	  }
        }
	if (RetVal != 0-2)
	{
          MessageBeep(MB_ICONASTERISK);
          MessageBox(hDlg, "This is the end of your program.  No SYSND! or ND command specified.", "End of Program", MB_OK | MB_ICONASTERISK);
          fcloseall();
	  EndDialog(hDlg, 0);
	}
	if (RetVal == 0-2)
	{
	  fcloseall();
	  EndDialog(hDlg, 0);
	}
        return 0;
      }
      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMOldSLOSDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMOldSLOSDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 2 :
     {
       MessageBeep(MB_ICONASTERISK);
       if (MessageBox(hDlg, "USE THIS AS A LAST RESORT!!  If your current program isn't responding to the system, wait at least 5 seconds before doing this!  Closing this program in this way can result in data loss and/or corruption.  Are you still sure you want to force the closing?", "Forced-Closing Warning", MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2) == IDYES)
       {
         EndDialog(hDlg, 0);
       }
       break;
     }
   }
}

BOOL FAR PASCAL _export IllegalValue(HWND hWnd, char Command[142], char ErrorString[200], int LinePos)
{
  DLGPROC AbtDlgProc;

  strcpy(Err, Command);
  AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)ErrorDlgProc, ghInstance);
  DialogBoxParam(dllInstance, "ERROR", hWnd, AbtDlgProc, (LPARAM) ErrorString);
  FreeProcInstance((FARPROC)AbtDlgProc);
  if (erv == 4)
  {
    AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)Retry10DlgProc, ghInstance);
    DialogBoxParam(dllInstance, "RETRY10", hWnd, AbtDlgProc, (LPARAM) LinePos);
    FreeProcInstance((FARPROC)AbtDlgProc);
  }
  return erv;
}

#pragma argsused
void WMErrorDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 3 :
     {
       erv = 3;
       EndDialog(hDlg, 0);
       break;
     }
     case 4 :
     {
       erv = 4;
       EndDialog(hDlg, 0);
       break;
     }
     case 5 :
     {
       erv = 5;
       EndDialog(hDlg, 0);
       break;
     }
   }
}

#pragma argused
BOOL CALLBACK _export ErrorDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	SetDlgItemText(hDlg, 200, gns);
	SetDlgItemText(hDlg, 201, Err);
	SetDlgItemText(hDlg, 202, (LPSTR) lParam);
	return TRUE;
      }
      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMErrorDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMRetry10DlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
     case 2 :
     {
       erv = 3;
       EndDialog(hDlg, 0);
       break;
     }
     case 4 :
     {
       erv = 4;
       EndDialog(hDlg, 0);
       break;
     }
     case 202 :
     {
       char NewValue[142];
       char OldValue[142];
       int LinePos = GetDlgItemInt(hDlg, 203, NULL, FALSE);
       GetDlgItemText(hDlg, 200, OldValue, 142);
       GetDlgItemText(hDlg, 201, NewValue, 142);
       if (strcmp(NewValue, OldValue) != 0)
       {
	 int t;
         char TmpTmp[142];
         long BefPos;
	 FILE *TmpFile;
         BefPos = ftell(gfh);
	 TmpFile = tmpfile();
	 if (!TmpFile)
	 {
	   MessageBeep(MB_ICONSTOP);
	   MessageBox(hDlg, "Error saving your file!  Changes have not been saved.\n\nReason:\nFile Doesn't Exist", "Save Error", MB_OK | MB_ICONSTOP);
	   break;
         }
	 fseek(gfh, 0, SEEK_SET);
	 for (t=1; t<=(LinePos - 1); t++)
	 {
	   fgets(TmpTmp, 142, gfh);
	   fwrite(TmpTmp, strlen(TmpTmp), 1, TmpFile);
         }
	 fgets(TmpTmp, 142, gfh);
	 fwrite(NewValue, strlen(NewValue), 1, TmpFile);
	 fgets(TmpTmp, 142, gfh);
	 while (feof(gfh) == 0)
	 {
	   fwrite(TmpTmp, strlen(TmpTmp), 1, TmpFile);
	   fgets(TmpTmp, 142, gfh);
	 }
	 fclose(gfh);
	 fseek(TmpFile, 0, SEEK_SET);
	 gfh = fopen(gnf, "r+");
	 fgets(TmpTmp, 142, TmpFile);
	 while (feof(TmpFile) == 0)
	 {
	   fwrite(TmpTmp, strlen(TmpTmp), 1, gfh);
	   fgets(TmpTmp, 142, TmpFile);
	 }
	 fclose(TmpFile);
	 fclose(gfh);
	 gfh = fopen(gnf, "r");
         MessageBeep(MB_ICONASTERISK);
         MessageBox(hDlg, "File Saved.", "Save File", MB_OK | MB_ICONASTERISK);
	 fseek(gfh, BefPos, SEEK_SET);
       }
       break;
     }
   }
}

#pragma argused
BOOL CALLBACK _export Retry10DlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	SetDlgItemText(hDlg, 200, Err);
	SetDlgItemText(hDlg, 201, Err);
	SetDlgItemInt(hDlg, 203, (int) lParam, FALSE);
	return TRUE;
      }
      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMRetry10DlgCommand_Handler);
      }
   }

   return FALSE;
}
